/*
 * Created on Jan 15, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.operacijski_sustavi2.ECDSA;

import java.math.BigInteger;
import java.io.FileInputStream;
import java.security.SecureRandom;
import java.security.MessageDigest;
import com.dragongate_technologies.borZoi.*;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ECDSA {
	
	private ECDomainParameters ECDP;
	private ECPrivKey ECDSA_privkey;
	private ECPubKey ECDSA_pubkey;
	
	
	private MessageDigest sha;
	
	/* key generation */
	private ECPoint P;
	private BigInteger d; 
	private ECPointF2m Q;
	private SecureRandom rand;
	
	/* sig generation */
	private BigInteger k;
	private ECPointF2m pt;
	private BigInteger r;
	private BigInteger s;
	private BigInteger a;
	private BigInteger k_inv;
	
	/* sig verification  */
	private ECPointF2m pt1;
	private ECPointF2m pt2;

	
	
	public ECDSA(){
		
	
	}
	
	public ECPubKey ECDSAKeyGen(){
	
		System.out.print("DSA Key Generation:\n");
		/* 1. Select elliptic curve E defined over Zp */
		ECDP=ECDomainParameters.NIST_B_163();
		
		/* 3. Select a statistically unique and unpredictable integer d */
		rand=new SecureRandom();
		d=new BigInteger(ECDP.m, rand);
			
		/* 4. Compute Q=dP*/
		Q=(ECPointF2m)ECDP.E.mul(d, ECDP.G);
		
		/* 5. */
		ECDSA_privkey=new ECPrivKey(ECDP, d);
		ECDSA_pubkey=new ECPubKey(ECDP, Q);
		
		System.out.println("d = "+d);
		System.out.println("Q = "+Q);
		
		return ECDSA_pubkey;
		
	}

	public BigInteger[] ECDSASigGen(ECPrivKey A_priv_key, String FName) throws Exception{
		
		System.out.print("DSA Signature Generation:\n");
		BigInteger sig[]={ BigInteger.valueOf(0), BigInteger.valueOf(0)};
		
		rand=new SecureRandom();
		k=new BigInteger(A_priv_key.dp.m, rand);
		
		pt=(ECPointF2m)A_priv_key.dp.E.mul(k, A_priv_key.dp.G);
		do{
			r=pt.x.val.mod(A_priv_key.dp.r);
		}while(r.compareTo(new BigInteger("0"))==0);
		
		a=GetHash(FName);
	
		a=a.add(d.multiply(r));
		a=a.mod(A_priv_key.dp.r);
		k_inv=k.modInverse(A_priv_key.dp.r);
		s=k_inv.multiply(a);
		s=s.mod(A_priv_key.dp.r);
		
		sig[0]=r;
		sig[1]=s;
	
		System.out.println("r = "+sig[0]);
		System.out.println("s = "+sig[1]);
		
		return sig;
	}
	
	public boolean ECDSASigVer(ECPubKey A_key, BigInteger[] sig, String FName) throws Exception{
		
		System.out.print("DSA Signature Verification:\n");
		BigInteger digest=GetHash(FName);
		
		if(A_key.dp.r.compareTo(sig[0])<0 && 
				A_key.dp.r.compareTo(sig[0])<0) return false;
		
		BigInteger w=sig[1].modInverse(A_key.dp.r);
		BigInteger u1=digest.multiply(w);
		BigInteger u2=sig[0].multiply(w);
		u2=u2.mod(A_key.dp.r);
		
		pt1=(ECPointF2m)A_key.dp.E.mul(u1, A_key.dp.G);
		pt2=(ECPointF2m)A_key.dp.E.mul(u2, A_key.W);
		
		pt1=(ECPointF2m)A_key.dp.E.add(pt1, pt2);
		
		BigInteger v=pt1.x.val.mod(A_key.dp.r);
		
		System.out.println("w = "+w);
		System.out.println("u1 = "+u1);
		System.out.println("u2 = "+u2);
		System.out.println("v = "+v);
				
		if(v.compareTo(sig[0])==0) return true;
		else return false;
		
	}
	
	
	private BigInteger GetHash(String FName) throws Exception{
		
		String byte_string;

		sha = MessageDigest.getInstance("SHA");
		FileInputStream fis = new FileInputStream(FName);
		byte[] dataBytes = new byte[1024];
		int nread = fis.read(dataBytes);
		while (nread > 0) {
			sha.update(dataBytes, 0, nread);
			nread = fis.read(dataBytes);
		};
		byte[] mdbytes = sha.digest();
		
		
		for(int i=0; i<mdbytes.length; i++){
			byte_string=Integer.toHexString(mdbytes[i]);
			if (mdbytes[i] < 0) {
			    byte_string = byte_string.substring(6);
			}
		}

		return  new BigInteger(mdbytes);
	}
	
	public ECPrivKey getECDSA_privkey() {
		return ECDSA_privkey;
	}
}
